/* 2011: S.K. Feng, Brookhaven National Laboratory
 * This file is added to support RTEMS/PowerPC commands in accessing 
 * hardware I/O address.
 */

#include <libcpu/io.h>

static void writeReg8(volatile void *a8,epicsUInt8 value)
{
#if (defined(__rtems__) && defined(__PPC__))
   out_8((volatile unsigned char *) a8, value);
#else
   *a8 = value;
#endif
}

static epicsUInt8 readReg8(volatile void *a8)
{
#if (defined(__rtems__) && defined(__PPC__))
    return in_8((volatile unsigned char *) a8);
#else
    epicsUInt8 value;

    value = *a8;
    return(value);
#endif
}

static void writeReg16(volatile void *a16, epicsUInt16 value)
{
#if (defined(__rtems__) && defined(__PPC__))
    out_be16((volatile unsigned short *) a16, value);
#else
    volatile epicsUInt16 *reg;

    reg = (volatile epicsUInt16 *)a16;
    *reg = value;
#endif
}

static epicsUInt16 readReg16(volatile void *a16)
{

#if (defined(__rtems__) && defined(__PPC__))
    return in_be16((volatile unsigned short *) a16);
#else
    volatile epicsUInt16 *reg;
    epicsUInt16 value;

    reg = (volatile epicsUInt16 *)a16;
    value = *reg;
    return(value);
#endif
}

static void writeReg32(volatile void *a32, epicsUInt32 value)
{
#if (defined(__rtems__) && defined(__PPC__))
    out_be32((volatile unsigned *) a32, value);
#else
    volatile epicsUInt32 *reg;

    reg = (volatile epicsUInt32 *)a32;
    *reg = value;
#endif
}

static epicsUInt32 readReg32(volatile void *a32)
{

#if (defined(__rtems__) && defined(__PPC__))
    return in_be32((volatile unsigned *)a32);
#else
    volatile epicsUInt32 *reg;
    epicsUInt32 value;

    reg = (volatile epicsUInt32 *)a32;
    value = *reg;
    return(value);
#endif
}
